/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getCharOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getCharOperationDispatcher. It contains of all the generic methods
    for getCharOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getCharOperationDispatcher_HXX
#define getCharOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getCharOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getCharOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getCharOperationDispatcher();
        virtual ~getCharOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getCharPreConditions( const Teamcenter::BusinessObject* obj, char& charValue, bool& isNull ) const;
        void getCharPreActions( const Teamcenter::BusinessObject* obj, char& charValue, bool& isNull ) const;
        void getCharBaseAction( const Teamcenter::BusinessObject* obj, char& charValue, bool& isNull ) const;
        void getCharPostActions( const Teamcenter::BusinessObject* obj, char& charValue, bool& isNull ) const;

        // Project 011450 changes
        void getCharPreConditions( METHOD_message_t*  msgData, char* value, logical* isNull ) const;
        void getCharPreActions( METHOD_message_t*  msgData, char* value, logical* isNull ) const;
        void getCharBaseAction( METHOD_message_t*  msgData, char* value, logical* isNull ) const;
        void getCharPostActions( METHOD_message_t*  msgData, char* value, logical* isNull ) const;

        void getChar( const Teamcenter::BusinessObject* obj, char& charValue, bool& isNull ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getCharOperationDispatcher_HXX
